include ..\czajnick.asm

AppMode .386
incboth user32
incboth kernel32
incboth oleaut32
include ..\aplib\aplib.inc
includelib ..\aplib\aplib.lib

UnpackFile PROTO :DWORD,:DWORD

stralloc MACRO ln
  api SysAllocStringByteLen,0,ln
ENDM

strfree MACRO strhandle
  api SysFreeString,strhandle
ENDM


.code
start:
  api  GetCommandLine
  .if  byte ptr [eax]=='"'
       mov  cl,'"'
  .else
       mov  cl," "
  .endif
  @@:
  inc  eax
  cmp  byte ptr [eax],cl
  jne  @B
  inc  eax
  .if  cl=='"'
       inc  eax
  .endif

  .if byte ptr [eax]==0
    api MessageBox,0,SADD("Podaj w linii polece nazw pliku do rozpakowania."),0,MB_OK or MB_ICONINFORMATION
    jmp wypad
  .endif

  api  UnpackFile,eax,eax
  
  wypad:
  api  ExitProcess,0

UnpackFile proc NameFile:DWORD,DestFile:DWORD
    LOCAL hFile          :DWORD
    LOCAL ln             :DWORD
    LOCAL br             :DWORD
    LOCAL dsize          :DWORD
    LOCAL source$        :DWORD
    LOCAL dest$          :DWORD

    api CreateFile,NameFile,GENERIC_READ,0,0,OPEN_EXISTING,0,0
    mov hFile, eax
    inc eax
    jz  _unpackret

    api GetFileSize,hFile,0
    mov ln, eax

    stralloc ln
    mov source$, eax

    api ReadFile,hFile,source$,ln,ADDR br,0

    api CloseHandle,hFile

    api aPsafe_get_orig_size,source$
    mov dsize, eax

    test eax,eax
    jnz @F
      api MessageBox,0,SADD("Nieprawidowy format pliku."),0,MB_OK or MB_ICONERROR
      strfree source$
      jmp _unpackret
    @@:
    stralloc dsize
    mov dest$, eax

    api aPsafe_depack_asm_fast,source$,dest$

    api CreateFile,DestFile,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
    mov hFile, eax
    inc eax
    jz  _unpackfree
    
    api WriteFile,hFile,dest$,dsize,ADDR br,0
    api CloseHandle,hFile

    _unpackfree:
    strfree source$
    strfree dest$

    _unpackret:
    ret
UnpackFile endp
end start